//+------------------------------------------------------------------+
//|                                              spread_on_chart.mq4 |
//|                                    Copyright  2010, Forexometer |
//|                                       http://www.forexometer.com |
//|                                           master@forexometer.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Forexometer"
#property link      "http://www.forexometer.com"

#property indicator_chart_window

extern string  _1="// --- Place settings ---";
extern int     Corner=0;
extern string  Corner_tips="// 0 - upper left, 1 - upper right, 2 - lower left, 3 - lower right";
extern double  XMargin=8;
extern double  YMargin=32;
extern string  _2="// --- Font settings ---";
extern string  Font="Lucida Console";
extern color   Color=LightGray;
extern double  Size=8;
extern double  LineRatio=1.5;

string strChartObjects[] = {
   "spread", "levels", "points", "ticks",
   "margininit", "marginmaintenance", "marginhedged",
   "marginrequired", "swaps"
   };
int intChartObjects;

double Pip, dblPoint, dblTickSize;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   intChartObjects = ArraySize( strChartObjects );
   
   Pip = Point;
   
   switch ( Digits )
	{
		case 3:
		case 5:
			Pip *= 10;
			break;
	}
   
   if((Corner==1 || Corner==3) && XMargin<1)  XMargin=1;
   if(XMargin<0)  XMargin=0;

   if(Corner>1 && YMargin<1)  YMargin=1;
   if(YMargin<0)  YMargin=0;

   for( int i = 0; i < intChartObjects; i++ )
   {
      ObjectCreate( strChartObjects[ i ], OBJ_LABEL, 0, 0, 0);
      ObjectSet( strChartObjects[ i ], OBJPROP_CORNER, Corner );
      ObjectSet( strChartObjects[ i ], OBJPROP_XDISTANCE, XMargin );
      ObjectSet( strChartObjects[ i ], OBJPROP_YDISTANCE, YMargin + LineRatio*Size*i );
   }
   
   dblPoint    = MarketInfo( _Symbol, MODE_POINT );
   dblTickSize = MarketInfo( _Symbol, MODE_TICKSIZE );

   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{

   for( int i = 0; i < intChartObjects; i++ )
      ObjectDelete( strChartObjects[ i ] );

   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   double
      dblSpread = MarketInfo(Symbol(),MODE_SPREAD),
      dblTickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
      
   ObjectSetText("spread",
      "Spread: " + DoubleToStr(dblSpread,0) +
      " (" + DoubleToStr(dblSpread * dblPoint * dblTickValue / dblTickSize, 1 ) + ")" +
      "; Market: " + MarketInfo(Symbol(),MODE_TRADEALLOWED)
      , Size,Font,Color);

   ObjectSetText("levels",
   	"Level - Stop: " + DoubleToStr(MarketInfo(Symbol(),MODE_STOPLEVEL),0) +
   	", Freeze: " + DoubleToStr(MarketInfo(Symbol(),MODE_FREEZELEVEL),0)
   	,Size,Font,Color);

   ObjectSetText("points",
   	"Point: " + DoubleToStr(dblPoint,Digits) +
   	", Digits: " + DoubleToStr(MarketInfo(Symbol(),MODE_DIGITS),0)
   	,Size,Font,Color);

   ObjectSetText("ticks",
   	"Tick: " + DoubleToStr(dblTickSize,Digits) +
   	", Value: " + DoubleToStr(dblTickValue,Digits)
   	,Size,Font,Color);

   ObjectSetText("margininit",
   	"Margin (Init): " + DoubleToStr(MarketInfo(Symbol(),MODE_MARGININIT),Digits)
   	,Size,Font,Color);
   	
   ObjectSetText("marginmaintenance",
   	"Margin (Maintenance): " + DoubleToStr(MarketInfo(Symbol(),MODE_MARGINMAINTENANCE),Digits)
   	,Size,Font,Color);
   	
   ObjectSetText("marginhedged",
      "Margin (Hedged): " + DoubleToStr(MarketInfo(Symbol(),MODE_MARGINHEDGED),0)
      ,Size,Font,Color);
      
   ObjectSetText("marginrequired",
      "Margin (Required): " + DoubleToStr(MarketInfo(Symbol(),MODE_MARGINREQUIRED),2)
      ,Size,Font,Color);

   ObjectSetText("swaps",
      "Swaps " +
      "L: " + DoubleToStr(MarketInfo(Symbol(),MODE_SWAPLONG),Digits) +
      "; S: " + DoubleToStr(MarketInfo(Symbol(),MODE_SWAPSHORT),Digits) 
      ,Size,Font,Color);

   return(0);
}
//+------------------------------------------------------------------+

